// TestAPI.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "../../../Windows/user_dll_source/dll/User_Api.h"
#include "../../../Windows/user_dll_source/dll/PET_Type.h"

#include <stdio.h>
#include <stdlib.h>


#pragma comment(lib, "../../Release/PET.lib")

#define	BOARD_INFO		1
#define	HWM_TEST		1
#define	CPU_Info		1
#define EC_IIC_Word		1
#define EC_IIC_Byte		0
#define EC_IIC_Quick	0
#define WDT_TEST		1
#define WDT_ACTION		0
#define	GPIO_DIR		0
#define	GPIO_DIR2		0
#define	GPIO_INOU		0
#define	GPIO_INOU2		0
#define	TEST_INPUT		0
#define	TEST_INPUT2		0
#define	SMBUS_TEST		1
#define	ECSMBUS_TEST	0
#define	BLC_TEST		0
#define	BEEP_TEST		1
#define	NOTE_TEST		0
#define IIC_TEST		0

int _tmain(int argc, _TCHAR* argv[])
{
	int i, j;
	int error_code;
    char temp [10];

	unsigned char gpio_value, gpio_pin, gpio_direction;
	int cpu_num;
    double systemp = 0;
	double cputemp = 0;
	double voltage = 0;
    int fan_value = 0;
	int fan_ratio = 0;

    int wdt_type = 0;
	unsigned char wdt_timeout = 10;
    unsigned char wdt_min = 0;
	unsigned char wdt_max = 0;

	unsigned char slave_addr = 0xA0; //SPD
	//unsigned char slave_addr = 0xD2; //ClockGen
	unsigned char offset = 0x00;  
	unsigned char smbus_value;
	unsigned char blc_ratio = 50; // set 50%

	//for ec iic function
	unsigned char slaveAddress=0xAE;
	int address=0x00;
	unsigned char value[32];
	unsigned char status=0;
	int length=0;		
	int iEnd=0;	
	unsigned char quick_value;

	error_code = PET_API_Init();
	if (error_code != NOERROR)
	{
		printf("API init fail, error code = %d\n", error_code);
		PET_API_Uninit ();
		Sleep (200);
		return 1;
	}

	printf ("==== Portwell Inc ====\n");

#if BOARD_INFO

	error_code = PET_API_GetVersion (temp);
    if (error_code == NOERROR)
        printf ("PET API Version: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The PET API function no support.\n");
	else
		printf ("Get API version error, error number %d\n", error_code);

	error_code = PET_Board_GetPlatformName (temp); 
    if (error_code == NOERROR)
		printf ("Board name: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The Board name function no support.\n");
	else
        printf ("Get board name error, error number %d\n", error_code);

	error_code = PET_Board_GetBIOSVersion (temp);
    if (error_code == NOERROR)
        printf ("PET Board BIOS Version: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The Board BIOS Version function no support.\n");
	else
		printf ("Get BIOS version error, error number %d\n", error_code);


/*
	error_code = PET_API_SetIOSleepTime (10); // 10u second
    if (error_code == NOERROR)
        printf ("Set I/O sleep time is successful\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The function no support.\n");
	else
		printf ("Set I/O sleep time error, error number %d\n", error_code);
*/
#endif

#if HWM_TEST

	printf ("\n==== Hardware Monitor ====\n");

	error_code = PET_HWM_CPUTemperature (0, &cputemp);
	if (error_code == NOERROR)
        printf ("CPU temperature value is %3.2f\n", cputemp);
	else if (error_code == NOT_SUPPORT)
		printf ("The CPU temperature function no support.\n");
	else
        printf ("Get CPU temperature error, error number %d\n", error_code);
		
	error_code = PET_HWM_SysTemperature (&systemp);
	if (error_code == NOERROR)
        printf ("System temperature value is %3.2f\n", systemp);
	else if (error_code == NOT_SUPPORT)
		printf ("The System temperature function no support.\n");
	else
        printf ("Get System temperature error, error number %d\n", error_code);

	error_code = PET_HWM_Voltage (VOL_VCORE, &voltage);
    if (error_code == NOERROR)
		printf ("The VCORE value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The VCORE function no support.\n");
	else
        printf ("Get VCORE value error, error number %d\n", error_code);
    
	error_code = PET_HWM_Voltage (VOL_VCCDDR, &voltage);
	if (error_code == NOERROR)
       printf ("The VCC DDR value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The VCC DDR function no support.\n");
	else
       printf ("Get VCC DDR value error, error number %d\n", error_code);		

    error_code = PET_HWM_Voltage (VOL_3P3V, &voltage);
	if (error_code == NOERROR)
       printf ("The 3.3V value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The VOL_VCC function no support.\n");
	else	
        printf ("Get VOL_VCC value error, error number %d\n", error_code); 

    error_code = PET_HWM_Voltage (VOL_VCC, &voltage);
	if (error_code == NOERROR)
       printf ("The Vcc value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The Vcc function no support.\n");
	else	
        printf ("Get Vcc value error, error number %d\n", error_code); 

    error_code = PET_HWM_Voltage (VOL_12V, &voltage);
	if (error_code == NOERROR)
        printf ("The 12V value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The 12V function no support.\n");
	else	
        printf ("Get 12V value error, error number %d\n", error_code);
/*  
    error_code = PET_HWM_Voltage (VOL_24V, &voltage);
	if (error_code == NOERROR)
        printf ("The 24V value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The 24V function no support.\n");
	else	
        printf ("Get 24V value error, error number %d\n", error_code);

	error_code = PET_HWM_Voltage (VOL_VBAT, &voltage);
    if (error_code == NOERROR)
		printf ("The VBAT value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The VBAT function no support.\n");
	else
        printf ("Get VBAT value error, error number %d\n", error_code);
*/

/*	
	fan_ratio = 50;
	error_code = PET_HWM_SetFanSpeed (CPUFAN, fan_ratio);
	if (error_code == NOERROR)
		printf ("Set CPU fan speed ratio: %d%%\n", fan_ratio);
	else if (error_code == NOT_SUPPORT)
		printf ("Set CPU fan speed function no support.\n");
	else
        printf ("Set CPU fan speed error, error number %d\n", error_code);


	fan_ratio = 80;
	error_code = PET_HWM_SetFanSpeed (SYSFAN, fan_ratio);
	if (error_code == NOERROR)
		printf ("Set SYSFAN fan speed ratio: %d%%\n", fan_ratio);
	else if (error_code == NOT_SUPPORT)
		printf ("Set SYSFAN fan speed function no support.\n");
	else
        printf ("Set SYSFAN fan speed error, error number %d\n", error_code);
*/	

	error_code = PET_HWM_GetFanSpeed (CPUFAN, &fan_value);
	if (error_code == NOERROR)
		printf ("CPU fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("CPU fan speed function no support.\n");
	else
        printf ("Get CPU fan speed error, error number %d\n", error_code); 

    error_code = PET_HWM_GetFanSpeed (SYSFAN, &fan_value);
    if (error_code == NOERROR)
		printf ("System fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("System fan speed function no support.\n");
	else
        printf ("Get CPU fan speed error, error number %d\n", error_code);

#endif

#if CPU_Info
	printf ("\n==== Cpu Information ====\n");
	CpuInfo cpu;
	PET_New_CPU_Obj(&cpu);			
	
	//static
	printf("Vendor:%s\n",cpu.vendorName);
	printf("Family:%X\n",cpu.familyId);
	printf("Model:%X\n",cpu.modeId);
	printf("Stepping:%X\n",cpu.steppingId);
	printf("Type:%X\n",cpu.typeId);
	printf("TjMax:%d\n",cpu.tjMax);	
	//printf("MaxFrequency:%dMHz\n",cpu.maxFrequency);

	printf("-----------------Cache Size Info--------------------\n");
	printf("%s\n",cpu.CacheL1);
	printf("%s\n",cpu.CacheL2);
	printf("%s\n",cpu.CacheL3);

	printf("-----------------Cache TLB Info--------------------\n");	
	for(i=0;i<cpu.cacheTlbInfoLength;i++)
	{
		printf("%d:",(i+1));
		printf("%s\n",cpu.cacheTlbInfo[i]);
	}

	printf("-----------------Cpu Feature--------------------\n");
	for(i=0;i<cpu.featuresLength;i++)
	{
		printf("%d:",(i+1));
		printf("%s\n",cpu.features[i]);		
	}


	printf("-------------------------------------\n");
	printf("Cpu Temperature:%d\n",cpu.getCpuTemperature());
	printf("CurrentFrequency:%d\n",cpu.getCurrentFrequency());
	printf("Voltage:%f\n",cpu.getVoltage());
	printf("-------------------------------------\n");

#endif

#if EC_IIC_Word
	printf ("\n====EC IIC Test====\n");
	printf("-------------------Word Address--------------------\n");
	printf("-----------------------Write-----------------------\n");
	address=0x00;
	length=8;
	iEnd=512/length;

	for(i=0;i<length;i++)
		value[i]=i;		

	for(i=0;i<iEnd;i++)
	{
		error_code=PET_EC_IIC_Word_Addr_Write(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Write:");
			for(j=0;j<length;j++)
			{				
				printf("%X,",value[j]);
				value[j]+=length;				
			}
			printf("to %X\n",address);
			address+=length;
		}else
		{
			printf("Write Error\n");
			break;
		}

	}
	
	printf("-------------------Word Address--------------------\n");
	printf("-----------------------Read-----------------------\n");

	length=8;	
	address=0x00;	
	for(i=0;i<iEnd;i++)
	{				
		error_code=PET_EC_IIC_Word_Addr_Read(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Read:");
			for(j=0;j<length;j++)
			{
				printf("%X,",value[j]);				
			}
			printf("from %X\n",address);
			address+=length;
		}else
		{
			printf("Read Error\n");
			break;
		}	
	}	
	printf("---------------------------------------------------\n");
#endif

#if EC_IIC_Byte
	printf ("\n====EC IIC Test====\n");
	printf("-------------------Byte Address--------------------\n");
	printf("-----------------------Write-----------------------\n");
	address=0x00;
	length=8; 
	iEnd=256/length;

	for(i=0;i<length;i++)
		value[i]=i;	

	for(i=0;i<iEnd;i++)
	{
		error_code=PET_EC_IIC_Byte_Addr_Write(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Write:");
			for(j=0;j<length;j++)
			{				
				printf("%X,",value[j]);
				value[j]+=length;				
			}
			printf("to %X\n",address);
			address+=length;
		}else
		{
			printf("Write Error\n");
			break;
		}

	}
	
	printf("-------------------Byte Address--------------------\n");
	printf("-----------------------Read-----------------------\n");

	length=8;	
	address=0x00;	
	for(i=0;i<iEnd;i++)
	{				
		error_code=PET_EC_IIC_Byte_Addr_Read(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Read:");
			for(j=0;j<length;j++)
			{
				printf("%X,",value[j]);				
			}
			printf("from %X\n",address);
			address+=length;
		}else
		{
			printf("Read Error\n");
			break;
		}	
	}	
	printf("---------------------------------------------------\n");
#endif

#if EC_IIC_Quick
	printf ("\n====EC IIC Quick Read/Write Test====\n");
	printf("-------------------Byte Address--------------------\n");
	printf("-----------------------Write-----------------------\n");
	address=0x00;
	quick_value=0;
	iEnd=256;

	for(i=0;i<iEnd;i++)
	{
		error_code=PET_EC_IIC_Quick_Write(slaveAddress,address,&quick_value);
		if(error_code==0)
		{
			printf("Write:");				
			printf("%X,",quick_value);
			quick_value++;					
			printf("to %X\n",address);
			address++;
		}else
		{
			printf("Write Error\n");
			break;
		}

	}
	
	printf("-------------------Byte Address--------------------\n");
	printf("-----------------------Read-----------------------\n");
	
	address=0x00;	
	for(i=0;i<iEnd;i++)
	{				
		error_code=PET_EC_IIC_Quick_Read(slaveAddress,address,&quick_value);
		if(error_code==0)
		{
			printf("Read:");
			printf("%X,",value[j]);				
			printf("from %X\n",address);
			address++;
		}else
		{
			printf("Read Error\n");
			break;
		}	
	}	
	printf("---------------------------------------------------\n");
#endif	

#if WDT_TEST

	printf ("\n==== Test WDT Function ====\n");
	error_code = PET_WDT_GetRange (SECOND_MODE, &wdt_min, &wdt_max);
	if (error_code == NOERROR)
    	printf ("The WDT seconde mode range: %d ~ %d (sec)\n", wdt_min, wdt_max);
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT range function no support.\n");
	else
		printf ("Get WDT range error, error number %d\n", error_code);

	error_code = PET_WDT_SetConfig (wdt_type, wdt_timeout);
	if (error_code == NOERROR)
		printf ("WDT setting is successful.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT setting function no support.\n");
	else
		printf ("WDT setting error, error code %d\n", error_code);

	error_code = PET_WDT_GetConfig (&wdt_type, &wdt_timeout);
	if (error_code == NOERROR)
        printf ("WDT type:%d, timeout:%d\n", wdt_type, wdt_timeout);
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT get config function no support.\n");
	else
		printf ("The WDT get config error, error code %d\n", error_code);

    error_code = PET_WDT_Trigger ();
	if (error_code == NOERROR)
        printf ("WDT Trigger NOW !!\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT trigger function no support.\n");
	else
		printf ("The WDT trigger error, error code %d\n", error_code);
/*
	error_code = PET_WDT_Available ();
	if (error_code == NOERROR)
   		printf ("WDT trigger is available.\n");
	else if (error_code == NOT_READY)
	    printf ("The WDT is not Ready.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT available function no support.\n");
	else
		printf ("The WDT available error, error code %d\n", error_code);
*/
    #if WDT_ACTION
        for (i = 1; i <= wdt_timeout; i++)
        {
            printf ("Reset counter ......%d\n", wdt_timeout - i);
            Sleep (1000);
		}	
    #else
        for (i = 1; i <= wdt_timeout; i++)
        {
            printf ("Reset counter ......%d\n", wdt_timeout - i);
            if (i == 6)
            {
                PET_WDT_Disable ();
                printf ("Last %d second...stop WDT trigger\n", wdt_timeout - i);
                break;
            }
            Sleep (1000);
        }
    #endif

#endif

#if	GPIO_DIR
	printf ("GPIO Direction Test.\n");

	error_code = PET_GPIO_SetDirection (1, 0x00); // 0 is output mode, 1 is input mode
	if (error_code == NOT_SUPPORT)
	{
		printf ("GPIO Direction Control no support.\n");
		goto GPIODIR_FIN;
	}
	else if (error_code != NOERROR)
	{
		printf ("GPIO Direction Control error, error number %d\n", error_code); 
		goto GPIODIR_FIN;
	}
	else
	{	
		PET_GPIO_Write (1, 0x00);
		PET_GPIO_ReadDirection (1, &gpio_direction);
		printf ("The GPIO Output direction 0x%02X\n", gpio_direction);
		Sleep (1000);

		PET_GPIO_SetDirection (1, 0xFF); // 0 is output mode, 1 is input mode
		PET_GPIO_ReadDirection (1, &gpio_direction);
		printf ("The GPIO Input direction 0x%02X\n", gpio_direction);
		Sleep (1000);

		for (i = 1; i <= 8; i++)
		{
			PET_GPIO_SetPinDirection (1, i, 0);
			PET_GPIO_ReadDirection (1, &gpio_direction);
			printf ("The pin %d: Input -> Output, value: 0x%02X\n", i, gpio_direction);
			Sleep (1000);
			
		}
	}

GPIODIR_FIN:
	printf ("GPIO Direction Test Finish..!!\n");

#endif

#if	GPIO_DIR2

	printf ("GPIO2 Direction Test.\n");

	error_code = PET_GPIO_SetDirection (2, 0); // 0 is output mode, 1 is input mode
	if (error_code == NOT_SUPPORT)
	{
		printf ("GPIO2 Direction Control no support.\n");
		goto GPIODIR2_FIN;
	}
	else if (error_code != NOERROR)
	{
		printf ("GPIO2 Direction Control error, error number %d\n", error_code); 
		goto GPIODIR2_FIN;
	}
	else
	{	
		PET_GPIO_Write (2, 0);
		PET_GPIO_ReadDirection (2, &gpio_direction);
		printf ("The GPIO2 Output direction 0x%02X\n", gpio_direction);
		Sleep (1000);

		PET_GPIO_SetDirection (2, 0xFF); // 0 is output mode, 1 is input mode
		PET_GPIO_ReadDirection (2, &gpio_direction);
		printf ("The GPIO2 Input direction 0x%02X\n", gpio_direction);
		Sleep (1000);

		for (i = 1; i <= 8; i++)
		{
			PET_GPIO_SetPinDirection (2, i, 0);
			PET_GPIO_ReadDirection (2, &gpio_direction);
			printf ("The pin %d: Input -> Output, value: 0x%02X\n", i, gpio_direction);
			Sleep (1000);
		}
	}
GPIODIR2_FIN:
	printf ("GPIO2 Direction Test Finish..!!\n");

#endif

#if GPIO_INOU

	printf ("GPIO Input/Output Test.\n");

	error_code = PET_GPIO_SetDirection (1, 0x00); // 0 is output mode, 1 is input mode
	if (error_code == NOT_SUPPORT)
	{
		printf ("GPIO Input/Output Control no support.\n");
		goto GPIOINOUT_FIN;
	}
	else if (error_code != NOERROR)
	{
		printf ("GPIO Input/Output Control error, error number %d\n", error_code); 
		goto GPIOINOUT_FIN;
	}
	else
	{	
		PET_GPIO_Write (1, 0xFF);
		PET_GPIO_Read (1, &gpio_value);
		printf ("Write all to 1: 0x%02X\n", gpio_value);
		Sleep (1000);

		PET_GPIO_Write (1, 0x00);
		PET_GPIO_Read (1, &gpio_value);
		printf ("Write all to 0: 0x%02X\n", gpio_value);
		Sleep (1000);

		printf ("Test GPIO1 ~8 set output mode\n");
		printf ("Test GPIO output every pin set value to 1\n");
		for(i = 1; i <= 8; i++)
		{
			PET_GPIO_WritePin (1, i, 1);
			PET_GPIO_Read (1, &gpio_value);
			printf ("Write PIN %d to 1, value = 0x%02X now\n", i, gpio_value);
			Sleep (1000);
		}

		printf ("Test GPIO output every pin set value to 0\n");
		for(i = 1; i <= 8; i++)
		{
			PET_GPIO_WritePin (1, i, 0);
			PET_GPIO_Read (1, &gpio_value);        
			printf ("Write PIN %d to 0, value = 0x%02X now\n", i, gpio_value);
			Sleep (1000);
		}
	}
GPIOINOUT_FIN:
	printf ("GPIO Input/Output Test Finish..!!\n");
#endif

#if GPIO_INOU2

	printf ("GPIO2 Input/Output Test.\n");

	error_code = PET_GPIO_SetDirection (2, 0); // 0 is output mode, 1 is input mode
	if (error_code == NOT_SUPPORT)
	{
		printf ("GPIO2 Input/Output Control no support.\n");
		goto GPIOINOUT_FIN;
	}
	else if (error_code != NOERROR)
	{
		printf ("GPIO2 Input/Output Control error, error number %d\n", error_code); 
		goto GPIOINOUT_FIN;
	} 
	else
	{	
		PET_GPIO_Write (2, 0xFF);
		PET_GPIO_Read (2, &gpio_value);
		printf ("Write GPIO2 all to 1: 0x%02X\n", gpio_value);
		Sleep (1000);

		PET_GPIO_Write (2, 0x00);
		PET_GPIO_Read (2, &gpio_value);
		printf ("Write GPIO2 all to 0: 0x%02X\n", gpio_value);
		Sleep (1000);

		printf ("Test GPIO2 1 ~8 set output mode\n");
		printf ("Test GPIO2 output every pin set value to 1\n");
		for(i = 1; i <= 8; i++)
		{
			PET_GPIO_WritePin (2, i, 1);
			PET_GPIO_Read (2, &gpio_value);
			printf ("Write PIN %d to 1, value = 0x%02X now\n", i, gpio_value);
			Sleep (1000);
		}

		printf ("Test GPIO2 output every pin set value to 0\n");
		for(i = 1; i <= 8; i++)
		{
			PET_GPIO_WritePin (2, i, 0);
			PET_GPIO_Read (2, &gpio_value);        
			printf ("Write PIN %d to 0, value = 0x%02X now\n", i, gpio_value);
			Sleep (1000);
		}
	}
GPIOINOUT2_FIN:
	printf ("GPIO2 Input/Output Test Finish..!!\n");
#endif

#if TEST_INPUT

	printf ("GPIO Input Test.\n");

	error_code = PET_GPIO_SetDirection (1, 0xFF); 
	if (error_code == NOT_SUPPORT)
	{
		printf ("GPIO Input control no support.\n");
		goto ENDGPIOTEST;
	}
	else if (error_code != NOERROR)
	{
		printf ("GPIO Input control error, error number %d\n", error_code); 
		goto ENDGPIOTEST;
	}
	else
	{	
		printf ("GPIO1 PIN 1 ~8 is set GPI (high) \n");
		printf ("Press put jumper to test... from PIN 1 ~ 8\n");
		printf ("Press PIN 8 put jumper to low will exit test.\n");

	

		i=1;
		while(1)
		{
			for (i = 1; i <=8; i++)
			{
				PET_GPIO_ReadPin (1, i, &gpio_value);
				if (gpio_value == 0)
				{
					if (i == 8)
						goto ENDGPIOTEST;
					else
					{
						printf("GPI1 PIN %d input pull low detect!\n", i);
						Sleep (500);
					}
				}
			}
		}
	}
ENDGPIOTEST:
	printf ("GPIO1 Input test finish\n");

#endif

#if TEST_INPUT2
	printf ("GPIO2 Input Test.\n");

	error_code = PET_GPIO_SetDirection (2, 0xFF); 
	if (error_code == NOT_SUPPORT)
	{
		printf ("GPIO2 Input control no support.\n");
		goto ENDGPIOTEST2;
	}
	else if (error_code != NOERROR)
	{
		printf ("GPIO2 Input control error, error number %d\n", error_code); 
		goto ENDGPIOTEST2;
	}
	else
	{	
		printf ("GPIO2 PIN 1 ~8 is set GPI (high) \n");
		printf ("Press put jumper to test... from PIN 1 ~ 8\n");
		printf ("Press PIN 8 put jumper to low will exit test.\n");

		i=1;
		while(1)
		{
			for (i = 1; i <=8; i++)
			{
				PET_GPIO_ReadPin (2, i, &gpio_value);
				if (gpio_value == 0)
				{
					if (i == 8)
						goto ENDGPIOTEST2;
					else
					{
						printf("GPI2 PIN %d input pull low detect!\n", i);
						Sleep (500);
					}
				}
			}
		}
	}
ENDGPIOTEST2:
	printf ("GPIO2 Input test finish\n");

#endif

#if SMBUS_TEST
	smbus_value = 0x00;
	printf ("\n==== Test SMBus read ====\n");
	printf ("   00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F\n");

	for (i = 0; i <= 0xF; i++)
	{
		printf ("%02X ", (i << 4));
		for (j = 0; j <= 0x0F; j++)
		{
			error_code = PET_SMBus_ByteData (SM_READ, slave_addr, offset, &smbus_value);
			if (error_code != NOERROR)
			{
				printf ("SMbus Slave addr 0x%02X no device, error code %d\n", slave_addr, error_code);
				goto SMB_FINISH;
			}
			printf ("%02X ", smbus_value);
			offset++;
		}
		printf ("\n");
	}
	printf ("\n");

SMB_FINISH:
	printf ("\n");
#endif 


#if ECSMBUS_TEST
	smbus_value = 0x00;
	offset = 0x00;
	printf ("\n==== Test EC SMBus read ====\n");
	printf ("   00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f\n");

	for (i = 0; i <= 0xF; i++)
	{
		printf ("%02X ", (i << 4));
		for (j = 0; j <= 0x0F; j++)
		{
			error_code = PET_EC_SMBus_ReadByte (slave_addr, offset, &smbus_value);
			if (error_code != NOERROR)
			{
				printf ("SMbus Slave addr 0x%02X no device, error code %d\n", slave_addr, error_code);
				goto ECSMB_FINISH;
			}
			printf ("%02X ", smbus_value);
			offset++;
		}
		printf ("\n");
	}
	printf ("\n");

	iic_data = 0;
	printf ("From EC_IIC Function\n");
	error_code = PET_EC_IIC_Read_Byte (slave_addr, &iic_data);
	if (error_code == NOERROR)
		printf ("Test OK, SPD value is 0x%2X\n", iic_data);

ECSMB_FINISH:
	printf ("\n");
#endif 

#if BLC_TEST
	
	error_code = PET_BLC_Available ();
	if (error_code == NOERROR)
		printf ("Blacklight control is available.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("Blacklight no support.\n");
	else
        printf ("Blacklight control error, error number %d\n", error_code);

	error_code = PET_BLC_Set_Brightness (blc_ratio);
	if (error_code == 0)
		printf ("Blacklight set %d%% successful.\n", blc_ratio);
	else if (error_code == NOT_SUPPORT)
		printf ("Blacklight setting no support.\n");
	else
        printf ("Blacklight setting error, error number %d\n", error_code);
	printf ("\n");

#endif

#if BEEP_TEST

	printf ("Beep alarm......");
		          // freq, sec
	PET_HWM_SetBeep (1000, 5); 
	printf ("END.\n");

#endif

#if	NOTE_TEST

	PET_HWM_SetMetronome (80);
	
	printf ("Play a song......");
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 2);

	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 4);

	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 2);

	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 2);

	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 1, 0, 4);
	
	printf ("finish!!\n");
#endif

#if IIC_TEST

	// Test Portwell IIC LED device

	// PET_IIC_Write_Bit (slave_address, bit_number, data point address);
	// bit numbert from 0 ~ 7  
	printf ("Test Portwell IIC LED Device.\n");
	error_code = PET_IIC_Available ();
	if (error_code == NOERROR)
	{
		iic_data = 0;
		for (i = 0; i < 8; i++)
		{
			error_code = PET_IIC_Write_Bit (0x40, i, &iic_data);
			if (error_code == NOERROR)
			{
				printf ("Write 0 to bit %d\n", i);
			}
			else
			{
				printf ("Write error\n");
				goto ENDING;
			}
			Sleep (1000);
		}

		iic_data = 1;
		for (i = 0; i < 8; i++)
		{
			PET_IIC_Write_Bit (0x40, i, &iic_data);
			if (error_code == NOERROR)
			{
				printf ("Write 1 to bit %d\n", i);
			}
			else
			{
				printf ("Write error\n");
				goto ENDING;
			}
			Sleep (1000);
		}
		printf ("IIC function test OK!!\n");
	}
	else
	{
		printf ("IIC is not available\n");
	}
#endif


ENDING:
	PET_API_Uninit ();
    return 0;
}
