#include "stdafx.h"
#include "../release/x86/User_Api.h"
#include "../release/x86/PET_Type.h"


#ifdef _M_X64
	#ifdef _DEBUG
		#pragma comment(lib, "../debug/x64/PETx64.lib")
	#else
		#pragma comment(lib, "../release/x64/PETx64.lib")
	#endif
#else 
	#ifdef _DEBUG
		#pragma comment(lib, "../debug/x86/PET.lib")
	#else
		#pragma comment(lib, "../release/x86/PET.lib")
	#endif
#endif

#define	BOARD_INFO		1
#define	HWM_TEST		1
#define CPU_Info		0
#define EC_SmartBattery 0
#define EC_IIC_Word		0
#define EC_IIC_Byte		1
#define	FAN_CONTROL		0
#define WDT_TEST		0
#define WDT_ACTION		0
#define	GPIO_DIR		0
#define	GPIO_DIR2		0
#define	GPIO_INOU		0
#define	GPIO_INOU2		0
#define	TEST_INPUT		0
#define	TEST_INPUT2		0
#define	SMBUS_TEST		0
#define	ECSMBUS_TEST	0
#define	BLC_TEST		0
#define	BEEP_TEST		0
#define	NOTE_TEST		0
#define	IIC_TEST		0



int main (int argc, char* argv[])
{
	int i, j;
	int error_code;
    char temp [50];
	unsigned char gpio_value, gpio_pin, gpio_direction;
	int cpu_num;
    double cputemp, systemp, voltage;
    int fan_value;
	int fan_ratio;

    int wdt_type = SECOND_MODE;
	unsigned char wdt_timeout = 10;
    unsigned char wdt_min, wdt_max;

	//unsigned char slave_addr = 0xA0; //SPD
	unsigned char slave_addr = 0xD2; //ClockGen
	unsigned char offset = 0x00;  
	unsigned char smbus_value;
	unsigned char iic_data;
	unsigned char blc_ratio = 50; // set 50%

	//for ec iic function
	unsigned char slaveAddress=0xAE;
	int address=0x00;
	unsigned char value[32];
	unsigned char status=0;
	int length=0;		
	int iEnd=0;	

	error_code = PET_API_Init();
	if (error_code != NOERROR)
	{
		if (error_code == NOSUPPORTED_PLATFORM)
			printf ("The PET API Library not support the board.\n");
		else
			printf("API init fail, error code = %d\n", error_code);
		PET_API_Uninit ();
		system ("pause");
		return 1;
	}



	//printf ("==== Portwell Inc ====\n");
	//printf ("XXXX-XXXX Demo PET API Sample.\n")
	//PET_GPIO_SetDirection (1, 0); // 0 is output mode, 1 is input mode
	//PET_GPIO_Write (1, 0xA0);
	/*
	printf ("WADE-8077 HDD failed LED TEST\n");
	PET_GPIO_SetDirection (1, 0x5F);
	PET_GPIO_Write (1, 0x00);
	printf ("LED is Rea light\n");
	system ("PAUSE");
	PET_GPIO_SetDirection (1, 0x00);
	PET_GPIO_Write (1, 0xA0);
	printf ("LED is Blue light\n");
	system ("PAUSE");
	PET_GPIO_SetDirection (1, 0x00);
	PET_GPIO_Write (1, 0x00);
	printf ("LED is White light\n");
	system ("PAUSE");
	PET_GPIO_SetDirection (1, 0xFF);
	PET_GPIO_Write (1, 0x00);
	printf ("Failed LED is light off\n");
	*/
#if BOARD_INFO
	printf ("==== Portwell Inc ====\n");

	error_code = PET_Board_GetPlatformName (temp); 
    if (error_code == NOERROR)
		printf ("Board name: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The Board name function no support.\n");
	else
        printf ("Get board name error, error number %d\n", error_code);

	error_code = PET_Board_GetBIOSVersion (temp);
    if (error_code == NOERROR)
        printf ("PET Board BIOS Version: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The Board BIOS function no support.\n");
	else
		printf ("Get BIOS version error, error number %d\n", error_code);
	
	error_code = PET_API_GetVersion (temp);
    if (error_code == NOERROR)
        printf ("PET API Version: %s\n", temp);
	else if (error_code == NOT_SUPPORT)
		printf ("The PET API function no support.\n");
	else
		printf ("Get API version error, error number %d\n", error_code);

/*
	error_code = PET_API_SetIOSleepTime (10); // 10u second
    if (error_code == NOERROR)
        printf ("Set I/O sleep time is successful\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The function no support.\n");
	else
		printf ("Set I/O sleep time error, error number %d\n", error_code);
*/
#endif

#if HWM_TEST

	printf ("\n==== Hardware Monitor ====\n");

	error_code = PET_HWM_CPUNumber (&cpu_num);
	if (error_code == NOERROR)
        printf ("CPU numbert is %d\n", cpu_num);
	else if (error_code == NOT_SUPPORT)
		printf ("The CPU numbert function no support.\n");
	else
        printf ("Get CPU numbert error, error number %d\n", error_code);

	error_code = PET_HWM_CPUTemperature (0, &cputemp);
	if (error_code == NOERROR)
        printf ("CPU temperature value is %3.2f\n", cputemp);
	else if (error_code == NOT_SUPPORT)
		printf ("The CPU temperature function no support.\n");
	else
        printf ("Get CPU temperature error, error number %d\n", error_code);
		
	error_code = PET_HWM_SysTemperature (&systemp);
	if (error_code == NOERROR)
        printf ("System temperature value is %3.2f\n", systemp);
	else if (error_code == NOT_SUPPORT)
		printf ("The System temperature function no support.\n");
	else
        printf ("Get System temperature error, error number %d\n", error_code);

	error_code = PET_HWM_Voltage (VOL_VCORE, &voltage);
    if (error_code == NOERROR)
		printf ("VCORE value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The VCORE function no support.\n");
	else
        printf ("Get VCORE value error, error number %d\n", error_code);
    
	error_code = PET_HWM_Voltage (VOL_VCCDDR, &voltage);
	if (error_code == NOERROR)
       printf ("The Vcc DDR value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The Vcc DDR function no support.\n");
	else
       printf ("Get Vcc DDR value error, error number %d\n", error_code);		

    error_code = PET_HWM_Voltage (VOL_3P3V, &voltage);
	if (error_code == NOERROR)
       printf ("The 3.3V value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The VOL_VCC function no support.\n");
	else	
        printf ("Get VOL_VCC value error, error number %d\n", error_code); 

    error_code = PET_HWM_Voltage (VOL_VCC, &voltage);
	if (error_code == NOERROR)
       printf ("The Vcc value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The Vcc function no support.\n");
	else	
        printf ("Get Vcc value error, error number %d\n", error_code); 

    error_code = PET_HWM_Voltage (VOL_12V, &voltage);
	if (error_code == NOERROR)
        printf ("The 12V value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The 12V function no support.\n");
	else	
        printf ("Get 12V value error, error number %d\n", error_code);

	error_code = PET_HWM_Voltage (VOL_VBAT, &voltage);
    if (error_code == NOERROR)
		printf ("The VBAT value is %3.3f (V)\n", voltage);
	else if (error_code == NOT_SUPPORT)
		printf ("The VBAT function no support.\n");
	else
        printf ("Get VBAT value error, error number %d\n", error_code);

/*
	fan_ratio = 50;
	error_code = PET_HWM_SetFanSpeed (CPUFAN, fan_ratio);
	if (error_code == NOERROR)
		printf ("Set CPU fan speed ratio: %d%%\n", fan_ratio);
	else if (error_code == NOT_SUPPORT)
		printf ("Set CPU fan speed function no support.\n");
	else
        printf ("Set CPU fan speed error, error number %d\n", error_code);

*/

	error_code = PET_HWM_GetFanSpeed (CPUFAN, &fan_value);
	if (error_code == NOERROR)
		printf ("CPU fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("CPU fan speed function no support.\n");
	else
        printf ("Get CPU fan speed error, error number %d\n", error_code); 

    error_code = PET_HWM_GetFanSpeed (SYSFAN, &fan_value);
    if (error_code == NOERROR)
		printf ("System fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("System fan speed function no support.\n");
	else
        printf ("Get System fan speed error, error number %d\n", error_code);

	error_code = PET_HWM_GetFanSpeed (AUXFAN, &fan_value);
    if (error_code == NOERROR)
		printf ("AUX fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("AUX fan speed function no support.\n");
	else
        printf ("Get AUX fan speed error, error number %d\n", error_code);
 
#endif

#if CPU_Info
	printf ("\n==== Cpu Information ====\n");
	CpuInfo cpu;
	PET_New_CPU_Obj(&cpu);			
	//static
	printf("Vendor:%s\n",cpu.vendorName);
	printf("Family:%X\n",cpu.familyId);
	printf("Model:%X\n",cpu.modeId);
	printf("Stepping:%X\n",cpu.steppingId);
	printf("Type:%X\n",cpu.typeId);
	printf("TjMax:%d\n",cpu.tjMax);	
	//printf("MaxFrequency:%dMHz\n",cpu.maxFrequency);

	printf("-----------------Cache Size Info--------------------\n");
	printf("%s\n",cpu.CacheL1);
	printf("%s\n",cpu.CacheL2);
	printf("%s\n",cpu.CacheL3);

	printf("-----------------Cache TLB Info--------------------\n");	
	for(i=0;i<cpu.cacheTlbInfoLength;i++)
	{
		printf("%d:",(i+1));
		printf("%s\n",cpu.cacheTlbInfo[i]);
	}

	printf("-----------------Cpu Feature--------------------\n");
	for(i=0;i<cpu.featuresLength;i++)
	{
		printf("%d:",(i+1));
		printf("%s\n",cpu.features[i]);		
	}


	printf("-------------------------------------\n");
	printf("Cpu Temperature:%d\n",cpu.getCpuTemperature());
	printf("CurrentFrequency:%d\n",cpu.getCurrentFrequency());
	printf("Voltage:%f\n",cpu.getVoltage());
	printf("-------------------------------------\n");
#endif

#if EC_SmartBattery
	printf ("\n====Test EC SmartBattery.====(500ms delay)\n");
	unsigned char address,code;
	unsigned char value[2];	
	address=0x16;
	code=0x00;
	int delayTime=10;
	Sleep(delayTime);
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);
	
	Sleep(delayTime);
	code=0x03;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x04;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x08;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x09;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x0A;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x0B;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x0C;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x0D;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x0F;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x10;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x14;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x15;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x16;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x17;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x18;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x1B;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	unsigned char value14[14];	
	code=0x20;
	PET_EC_SmartBattery(address,code,value14);
	printf("Address:%X, Code:%X,",address,code);
	for(int i=0;i<14;i++)
		printf(",%X",value14[i]);
	printf("\n");

	Sleep(delayTime);
	code=0x21;
	PET_EC_SmartBattery(address,code,value14);
	printf("Address:%X, Code:%X,",address,code);
	for(int i=0;i<14;i++)
		printf(",%X",value14[i]);
	printf("\n");

	Sleep(delayTime);
	unsigned char value6[6];	
	code=0x22;
	PET_EC_SmartBattery(address,code,value6);
	printf("Address:%X, Code:%X,",address,code);
	for(int i=0;i<6;i++)
		printf(",%X",value6[i]);
	printf("\n");

	Sleep(delayTime);
	code=0x23;
	PET_EC_SmartBattery(address,code,value14);
	printf("Address:%X, Code:%X,",address,code);
	for(int i=0;i<14;i++)
		printf(",%X",value14[i]);
	printf("\n");
	

	Sleep(delayTime);
	address=0x12;
	code=0x13;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	Sleep(delayTime);
	code=0x3C;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[0],value[1]);

	/*
	address=0x14;
	code=0x01;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[1],value[0]);

	code=0x02;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[1],value[0]);

	code=0x04;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[1],value[0]);

	code=0x3c;
	PET_EC_SmartBattery(address,code,value);
	printf("Address:%X, Code:%X, %X,%X\n",address,code,value[1],value[0]);
	*/
	
	
#endif

#if EC_IIC_Word
	printf ("\n====EC IIC Test====\n");
	printf("-------------------Word Address--------------------\n");
	printf("-----------------------Write-----------------------\n");
	address=0x00;
	length=8;
	iEnd=512/length;

	for(i=0;i<length;i++)
		value[i]=i;		

	for(i=0;i<iEnd;i++)
	{
		error_code=PET_EC_IIC_Word_Addr_Write(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Write:");
			for(j=0;j<length;j++)
			{				
				printf("%X,",value[j]);
				value[j]+=length;				
			}
			printf("to %X\n",address);
			address+=length;
		}else
		{
			printf("Write Error\n");
			break;
		}

	}
	
	printf("-------------------Word Address--------------------\n");
	printf("-----------------------Read-----------------------\n");

	length=8;	
	address=0x00;	
	for(i=0;i<iEnd;i++)
	{				
		error_code=PET_EC_IIC_Word_Addr_Read(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Read:");
			for(j=0;j<length;j++)
			{
				printf("%X,",value[j]);				
			}
			printf("from %X\n",address);
			address+=length;
		}else
		{
			printf("Read Error\n");
			break;
		}	
	}	
	printf("---------------------------------------------------\n");
#endif

#if EC_IIC_Byte
	printf ("\n====EC IIC Test====\n");
	/*
	PET_EC_IIC_Set_Frequency(F400K);
	printf("-------------------Byte Address(400K)--------------------\n");
	printf("-----------------------Write(400K)-----------------------\n");
	address=0x00;
	length=8; 
	iEnd=256/length;

	for(i=0;i<length;i++)
		value[i]=i;	

	for(i=0;i<iEnd;i++)
	{
		error_code=PET_EC_IIC_Byte_Addr_Write(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Write:");
			for(j=0;j<length;j++)
			{				
				printf("%X,",value[j]);
				value[j]+=length;				
			}
			printf("to %X\n",address);
			address+=length;
		}else
		{
			printf("Write Error\n");
			//break;
		}

	}
	
	printf("-------------------Byte Address(400K)--------------------\n");
	printf("-----------------------Read(400K)-----------------------\n");

	length=8;	
	address=0x00;	
	for(i=0;i<iEnd;i++)
	{				
		error_code=PET_EC_IIC_Byte_Addr_Read(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Read:");
			for(j=0;j<length;j++)
			{
				printf("%X,",value[j]);				
			}
			printf("from %X\n",address);
			address+=length;
		}else
		{
			printf("Read Error\n");
			//break;
		}	
	}	
	printf("---------------------------------------------------\n");
	*/
	/*
	PET_EC_IIC_Set_Frequency(F100K);
	Sleep(1000);
	printf("-------------------Byte Address(100K)--------------------\n");
	printf("-----------------------Write(100K)-----------------------\n");
	address=0x00;
	length=8; 
	iEnd=256/length;

	for(i=0;i<length;i++)
		value[i]=i;	

	for(i=0;i<iEnd;i++)
	{
		error_code=PET_EC_IIC_Byte_Addr_Write(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Write:");
			for(j=0;j<length;j++)
			{				
				printf("%X,",value[j]);
				value[j]+=length;				
			}
			printf("to %X\n",address);
			address+=length;
		}else
		{
			printf("Write Error\n");
			//break;
		}

	}
	
	printf("-------------------Byte Address(100K)--------------------\n");
	printf("-----------------------Read(100K)-----------------------\n");
	
	length=8;	
	address=0x00;	
	for(i=0;i<iEnd;i++)
	{				
		error_code=PET_EC_IIC_Byte_Addr_Read(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Read:");
			for(j=0;j<length;j++)
			{
				printf("%X,",value[j]);				
			}
			printf("from %X\n",address);
			address+=length;
		}else
		{
			printf("Read Error\n");
			//break;
		}	
	}	
	printf("---------------------------------------------------\n");
	*/
	
	PET_EC_IIC_Set_Frequency(F50K);
	printf("-------------------Byte Address(50K)--------------------\n");
	printf("-----------------------Write(50K)-----------------------\n");
	address=0x00;
	length=8; 
	iEnd=256/length;

	for(i=0;i<length;i++)
		value[i]=i;	

	for(i=0;i<iEnd;i++)
	{
		error_code=PET_EC_IIC_Byte_Addr_Write(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Write:");
			for(j=0;j<length;j++)
			{				
				printf("%X,",value[j]);
				value[j]+=length;				
			}
			printf("to %X\n",address);
			address+=length;
		}else
		{
			printf("Write Error\n");
			//break;
		}

	}
	
	printf("-------------------Byte Address(50K)--------------------\n");
	printf("-----------------------Read(50K)-----------------------\n");
	
	length=8;	
	address=0x00;	
	for(i=0;i<iEnd;i++)
	{				
		error_code=PET_EC_IIC_Byte_Addr_Read(slaveAddress,address,value,length);
		if(error_code==0)
		{
			printf("Read:");
			for(j=0;j<length;j++)
			{
				printf("%X,",value[j]);				
			}
			printf("from %X\n",address);
			address+=length;
		}else
		{
			printf("Read Error\n");
			//break;
		}	
	}	
	printf("---------------------------------------------------\n");
	
#endif

#if FAN_CONTROL
	//Fan speed testing
	int waitStableTime=10;
	//***************************Fan speed 0%**************************
	fan_ratio = 0;
	error_code = PET_HWM_SetFanSpeed (SYSFAN, fan_ratio);
	if (error_code == NOERROR)
	{
		printf ("Set System fan speed ratio: %d%%\n", fan_ratio);
		printf ("Wait for stably fan-speed...");
		for(i=0;i<waitStableTime;i++)
		{
			printf("%d..",i+1);
			Sleep(1000);
		}
		printf("\n");
	}
	else if (error_code == NOT_SUPPORT)
		printf ("Set System fan speed function no support.\n");
	else
        printf ("Set System fan speed error, error number %d\n", error_code);


	
	error_code = PET_HWM_GetFanSpeed (SYSFAN, &fan_value);
    if (error_code == NOERROR)
		printf ("System fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("System fan speed function no support.\n");
	else
        printf ("Get System fan speed error, error number %d\n", error_code);


		

	//***************************Fan speed 50%**************************
	
	fan_ratio = 50;
	error_code = PET_HWM_SetFanSpeed (SYSFAN, fan_ratio);
	if (error_code == NOERROR)
	{
		printf ("Set System fan speed ratio: %d%%\n", fan_ratio);
		printf ("Wait for stably fan-speed...");
		for(i=0;i<waitStableTime;i++)
		{
			printf("%d..",i+1);
			Sleep(1000);
		}
		printf("\n");
	}
	else if (error_code == NOT_SUPPORT)
		printf ("Set System fan speed function no support.\n");
	else
        printf ("Set System fan speed error, error number %d\n", error_code);


	
	error_code = PET_HWM_GetFanSpeed (SYSFAN, &fan_value);
    if (error_code == NOERROR)
		printf ("System fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("System fan speed function no support.\n");
	else
        printf ("Get System fan speed error, error number %d\n", error_code);

	//***************************Fan speed 100%**************************
	fan_ratio = 100;
	error_code = PET_HWM_SetFanSpeed (SYSFAN, fan_ratio);
	if (error_code == NOERROR)
	{
		printf ("Set System fan speed ratio: %d%%\n", fan_ratio);
		printf ("Wait for stably fan-speed...");
		for(i=0;i<waitStableTime;i++)
		{
			printf("%d..",i+1);
			Sleep(1000);
		}
		printf("\n");
	}
	else if (error_code == NOT_SUPPORT)
		printf ("Set System fan speed function no support.\n");
	else
        printf ("Set System fan speed error, error number %d\n", error_code);


	
	error_code = PET_HWM_GetFanSpeed (SYSFAN, &fan_value);
    if (error_code == NOERROR)
		printf ("System fan speed: %d\n", fan_value);
	else if (error_code == NOT_SUPPORT)
		printf ("System fan speed function no support.\n");
	else
        printf ("Get System fan speed error, error number %d\n", error_code);

	
#endif
#if WDT_TEST

	printf ("\n==== Test WDT Function ====\n");
	error_code = PET_WDT_GetRange (SECOND_MODE, &wdt_min, &wdt_max);
	if (error_code == NOERROR)
    	printf ("The WDT seconde mode range: %d ~ %d (sec)\n", wdt_min, wdt_max);
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT range function no support.\n");
	else
		printf ("Get WDT range error, error number %d\n", error_code);

	error_code = PET_WDT_SetConfig (wdt_type, wdt_timeout);
	if (error_code == NOERROR)
		printf ("WDT setting is successful.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT setting function no support.\n");
	else
		printf ("WDT setting error, error code %d\n", error_code);

	error_code = PET_WDT_GetConfig (&wdt_type, &wdt_timeout);
	if (error_code == NOERROR)
        printf ("WDT type:%d, timeout:%d\n", wdt_type, wdt_timeout);
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT get config function no support.\n");
	else
		printf ("The WDT get config error, error code %d\n", error_code);

    error_code = PET_WDT_Trigger ();
	if (error_code == NOERROR)
        printf ("WDT Trigger NOW !!\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT trigger function no support.\n");
	else
		printf ("The WDT trigger error, error code %d\n", error_code);

	error_code = PET_WDT_Available ();
	if (error_code == NOERROR)
   		printf ("WDT trigger is available.\n");
	else if (error_code == NOT_READY)
	    printf ("The WDT is not Ready.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("The WDT available function no support.\n");
	else
		printf ("The WDT available error, error code %d\n", error_code);

    #if WDT_ACTION
        for (i = 1; i <= wdt_timeout; i++)
        {
            printf ("Reset counter ......%d\n", wdt_timeout - i);
            Sleep (1000);
		}	
    #else
        for (i = 1; i <= wdt_timeout; i++)
        {
            printf ("Reset counter ......%d\n", wdt_timeout - i);
            if (i == 6)
            {
                PET_WDT_Disable ();
                printf ("Last %d second...stop WDT trigger\n", wdt_timeout - i);
                break;
            }
            Sleep (1000);
        }
    #endif

#endif

#if	GPIO_DIR

	PET_GPIO_SetDirection (1, 0); // 0 is output mode, 1 is input mode
	PET_GPIO_Write (1, 0);
	PET_GPIO_ReadDirection (1, &gpio_direction);
	printf ("The GPIO Output direction 0x%02X\n", gpio_direction);
	system ("PAUSE");
	PET_GPIO_SetDirection (1, 0xFF); // 0 is output mode, 1 is input mode
	PET_GPIO_ReadDirection (1, &gpio_direction);
	printf ("The GPIO Input direction 0x%02X\n", gpio_direction);
	system ("PAUSE");

	for (i = 1; i <= 8; i++)
	{
		PET_GPIO_SetPinDirection (1, i, 0);
		PET_GPIO_ReadDirection (1, &gpio_direction);
		printf ("The pin %d: Input -> Output, value: %X\n", i, gpio_direction);
		system ("PAUSE");
	}

#endif

#if	GPIO_DIR2

	PET_GPIO_SetDirection (2, 0); // 0 is output mode, 1 is input mode
	PET_GPIO_Write (2, 0);
	PET_GPIO_ReadDirection (2, &gpio_direction);
	printf ("The GPIO2 Output direction 0x%X\n", gpio_direction);
	system ("PAUSE");
	PET_GPIO_SetDirection (2, 0xFF); // 0 is output mode, 1 is input mode
	PET_GPIO_ReadDirection (2, &gpio_direction);
	printf ("The GPIO2 Input direction 0x%2X\n", gpio_direction);
	system ("PAUSE");

	for (i = 1; i <= 8; i++)
	{
		PET_GPIO_SetPinDirection (2, i, 0);
		PET_GPIO_ReadDirection (2, &gpio_direction);
		printf ("The pin %d: Input -> Output, value: %X\n", i, gpio_direction);
		system ("PAUSE");
	}

#endif

#if GPIO_INOU

	PET_GPIO_SetDirection (1, 0); // 0 is output mode, 1 is input mode

	PET_GPIO_Write (1, 0xFF);
	PET_GPIO_Read (1, &gpio_value);
	printf ("Write all to 1: 0x%2X\n", gpio_value);
	system ("PAUSE");

	PET_GPIO_Write (1, 0x00);
	PET_GPIO_Read (1, &gpio_value);
	printf ("Write all to 0: 0x%2X\n", gpio_value);
	system ("PAUSE");

	printf ("Test GPIO1 ~8 set output mode\n");
	printf ("Test GPIO output every pin set value to 1\n");
    for(i = 1; i <= 8; i++)
    {
        PET_GPIO_WritePin (1, i, 1);
        PET_GPIO_Read (1, &gpio_value);
        printf ("Write PIN %d to 1, value = %x now\n", i, gpio_value);
		system ("PAUSE");
    }

	printf ("Test GPIO output every pin set value to 0\n");
    for(i = 1; i <= 8; i++)
    {
        PET_GPIO_WritePin (1, i, 0);
        PET_GPIO_Read (1, &gpio_value);        
        printf ("Write PIN %d to 0, value = %x now\n", i, gpio_value);
		system ("PAUSE");
    }

#endif

#if GPIO_INOU2

	PET_GPIO_SetDirection (2, 0); // 0 is output mode, 1 is input mode

	PET_GPIO_Write (2, 0xFF);
	PET_GPIO_Read (2, &gpio_value);
	printf ("Write GPIO2 all to 1: 0x%2X\n", gpio_value);
	system ("PAUSE");

	PET_GPIO_Write (2, 0x00);
	PET_GPIO_Read (2, &gpio_value);
	printf ("Write GPIO2 all to 0: 0x%2X\n", gpio_value);
	system ("PAUSE");

	printf ("Test GPIO2 1 ~8 set output mode\n");
	printf ("Test GPIO2 output every pin set value to 1\n");
    for(i = 1; i <= 8; i++)
    {
        PET_GPIO_WritePin (2, i, 1);
        PET_GPIO_Read (2, &gpio_value);
        printf ("Write PIN %d to 1, value = %x now\n", i, gpio_value);
		system ("PAUSE");
    }

	printf ("Test GPIO2 output every pin set value to 0\n");
    for(i = 1; i <= 8; i++)
    {
        PET_GPIO_WritePin (2, i, 0);
        PET_GPIO_Read (2, &gpio_value);        
        printf ("Write PIN %d to 0, value = %x now\n", i, gpio_value);
		system ("PAUSE");
    }

#endif

#if TEST_INPUT

	printf ("GPIO1 PIN 1 ~8 is set GPI (high) \n");
	printf ("Press put jumper to test... from PIN 1 ~ 8\n");
	printf ("Press PIN 8 put jumper to low will exit test.\n");

	PET_GPIO_SetDirection (1, 0xFF); 

	i=1;
	while(1)
	{
		for (i = 1; i <=8; i++)
		{
			PET_GPIO_ReadPin (1, i, &gpio_value);
			if (gpio_value == 0)
			{
				if (i == 8)
					goto ENDGPIOTEST;
				else
				{
					printf("GPI1 PIN %d input pull low detect!\n", i);
					Sleep (500);
				}
			}
		}
	}
ENDGPIOTEST:
	printf ("GPI1 test finish\n");

#endif

#if TEST_INPUT2

	printf ("GPIO2 PIN 1 ~8 is set GPI (high) \n");
	printf ("Press put jumper to test... from PIN 1 ~ 8\n");
	printf ("Press PIN 8 put jumper to low will exit test.\n");

	PET_GPIO_SetDirection (2, 0xFF); 

	i=1;
	while(1)
	{
		for (i = 1; i <=8; i++)
		{
			PET_GPIO_ReadPin (2, i, &gpio_value);
			if (gpio_value == 0)
			{
				if (i == 8)
					goto ENDGPIOTEST2;
				else
				{
					printf("GPI2 PIN %d input pull low detect!\n", i);
					Sleep (500);
				}
			}
		}
	}
ENDGPIOTEST2:
	printf ("GPI2 test finish\n");

#endif

#if SMBUS_TEST
	smbus_value = 0x00;
	printf ("\n==== Test SMBus read ====\n");
	printf ("   00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f\n");

	for (i = 0; i <= 0xF; i++)
	{
		printf ("%02X ", (i << 4));
		for (j = 0; j <= 0x0F; j++)
		{
			error_code = PET_SMBus_ByteData (SM_READ, slave_addr, offset, &smbus_value);
			if (error_code != NOERROR)
			{
				printf ("SMbus Slave addr 0x%02X no device, error code %d\n", slave_addr, error_code);
				goto SMB_FINISH;
			}
			printf ("%02X ", smbus_value);
			offset++;
		}
		printf ("\n");
	}
	printf ("\n");

SMB_FINISH:
	printf ("\n");
#endif 

#if ECSMBUS_TEST
	smbus_value = 0x00;
	offset = 0x00;
	printf ("\n==== Test EC SMBus read ====\n");
	printf ("   00 01 02 03 04 05 06 07 08 09 0a 0b 0c 0d 0e 0f\n");

	for (i = 0; i <= 0xF; i++)
	{
		printf ("%02X ", (i << 4));
		for (j = 0; j <= 0x0F; j++)
		{
			error_code = PET_EC_SMBus_ReadByte (slave_addr, offset, &smbus_value);
			if (error_code != NOERROR)
			{
				printf ("SMbus Slave addr 0x%02X no device, error code %d\n", slave_addr, error_code);
				goto ECSMB_FINISH;
			}
			printf ("%02X ", smbus_value);
			offset++;
		}
		printf ("\n");
	}
	printf ("\n");

	iic_data = 0;
	printf ("From EC_IIC Function\n");
	error_code = PET_EC_IIC_Read_Byte (slave_addr, &iic_data);
	if (error_code == NOERROR)
		printf ("Test OK, SPD value is 0x%2X\n", iic_data);

ECSMB_FINISH:
	printf ("\n");
#endif 

#if BLC_TEST
	
	error_code = PET_BLC_Available ();
	if (error_code == NOERROR)
		printf ("Blacklight control is available.\n");
	else if (error_code == NOT_SUPPORT)
		printf ("Blacklight no support.\n");
	else
        printf ("Blacklight control error, error number %d\n", error_code);

	error_code = PET_BLC_Set_Brightness (blc_ratio);
	if (error_code == 0)
		printf ("Blacklight set %d%% successful.\n", blc_ratio);
	else if (error_code == NOT_SUPPORT)
		printf ("Blacklight setting no support.\n");
	else
        printf ("Blacklight setting error, error number %d\n", error_code);
	printf ("\n");

#endif

#if BEEP_TEST

	printf ("Beep alarm......");
		          // freq, sec
	PET_HWM_SetBeep (1000, 5); 
	printf ("END.\n");

#endif

#if	NOTE_TEST

	PET_HWM_SetMetronome (80);
	
	printf ("Play a song......");
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 2);

	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 4);

	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 2);

	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 2);

	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 2);
	PET_HWM_PlayNote (0, 4, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 1);
	PET_HWM_PlayNote (0, 2, 0, 2);

	PET_HWM_PlayNote (0, 1, 0, 1);
	PET_HWM_PlayNote (0, 3, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 5, 0, 1);
	PET_HWM_PlayNote (0, 1, 0, 4);
	
	printf ("finish!!\n");
#endif

#if IIC_TEST

	// Test Portwell IIC LED device

	// PET_IIC_Write_Bit (slave_address, bit_number, data point address);
	// bit numbert from 0 ~ 7  
	printf ("Test Portwell IIC LED Device.\n");
	error_code = PET_IIC_Available ();
	if (error_code == NOERROR)
	{
		iic_data = 0;
		for (i = 0; i < 8; i++)
		{
			error_code = PET_IIC_Write_Bit (0x40, i, &iic_data);
			if (error_code == NOERROR)
			{
				printf ("Write 0 to bit %d\n", i);
			}
			else
			{
				printf ("Write error\n");
				goto ENDING;
			}
			Sleep (1000);
		}

		iic_data = 1;
		for (i = 0; i < 8; i++)
		{
			PET_IIC_Write_Bit (0x40, i, &iic_data);
			if (error_code == NOERROR)
			{
				printf ("Write 1 to bit %d\n", i);
			}
			else
			{
				printf ("Write error\n");
				goto ENDING;
			}
			Sleep (1000);
		}
		printf ("IIC function test OK!!\n");
	}
	else
	{
		printf ("IIC is not available\n");
	}
#endif

ENDING:
	PET_API_Uninit ();
    system ("pause");
    return 0;
}